/*
 *                      Yeppp! library implementation
 *                  This file is auto-generated by Peach-Py,
 *       Portable Efficient Assembly Code-generator in Higher-level Python,
 *                   part of the Yeppp! library infrastrure
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp;

public class Core {
	static {
		System.loadLibrary("yeppp-jni");
	}

	// Vector addition
	public static native void Add_V8uV8u_V8u(byte[] xArray, byte[] yArray, byte[] sumArray, int length);
	public static native void Add_V8uV8u_V16u(byte[] xArray, byte[] yArray, short[] sumArray, int length);
	public static native void Add_V8sV8s_V16s(byte[] xArray, byte[] yArray, short[] sumArray, int length);
	public static native void Add_V16uV16u_V16u(short[] xArray, short[] yArray, short[] sumArray, int length);
	public static native void Add_V16uV16u_V32u(short[] xArray, short[] yArray, int[] sumArray, int length);
	public static native void Add_V16sV16s_V32s(short[] xArray, short[] yArray, int[] sumArray, int length);
	public static native void Add_V32uV32u_V32u(int[] xArray, int[] yArray, int[] sumArray, int length);
	public static native void Add_V32uV32u_V64u(int[] xArray, int[] yArray, long[] sumArray, int length);
	public static native void Add_V32sV32s_V64s(int[] xArray, int[] yArray, long[] sumArray, int length);
	public static native void Add_V64uV64u_V64u(long[] xArray, long[] yArray, long[] sumArray, int length);
	public static native void Add_V32fV32f_V32f(float[] xArray, float[] yArray, float[] sumArray, int length);
	public static native void Add_V64fV64f_V64f(double[] xArray, double[] yArray, double[] sumArray, int length);

	// Vector subtraction
	public static native void Subtract_V8uV8u_V8u(byte[] xArray, byte[] yArray, byte[] differenceArray, int length);
	public static native void Subtract_V8uV8u_V16u(byte[] xArray, byte[] yArray, short[] differenceArray, int length);
	public static native void Subtract_V8sV8s_V16s(byte[] xArray, byte[] yArray, short[] differenceArray, int length);
	public static native void Subtract_V16uV16u_V16u(short[] xArray, short[] yArray, short[] differenceArray, int length);
	public static native void Subtract_V16uV16u_V32u(short[] xArray, short[] yArray, int[] differenceArray, int length);
	public static native void Subtract_V16sV16s_V32s(short[] xArray, short[] yArray, int[] differenceArray, int length);
	public static native void Subtract_V32uV32u_V32u(int[] xArray, int[] yArray, int[] differenceArray, int length);
	public static native void Subtract_V32uV32u_V64u(int[] xArray, int[] yArray, long[] differenceArray, int length);
	public static native void Subtract_V32sV32s_V64s(int[] xArray, int[] yArray, long[] differenceArray, int length);
	public static native void Subtract_V64uV64u_V64u(long[] xArray, long[] yArray, long[] differenceArray, int length);
	public static native void Subtract_V32fV32f_V32f(float[] xArray, float[] yArray, float[] differenceArray, int length);
	public static native void Subtract_V64fV64f_V64f(double[] xArray, double[] yArray, double[] differenceArray, int length);

	// Vector negation
	public static native void Negate_V8s_V8s(byte[] numberArray, byte[] negatedNumberArray, int length);
	public static native void Negate_V16s_V16s(short[] numberArray, short[] negatedNumberArray, int length);
	public static native void Negate_V32s_V32s(int[] numberArray, int[] negatedNumberArray, int length);
	public static native void Negate_V64s_V64s(long[] numberArray, long[] negatedNumberArray, int length);
	public static native void Negate_V32f_V32f(float[] numberArray, float[] negatedNumberArray, int length);
	public static native void Negate_V64f_V64f(double[] numberArray, double[] negatedNumberArray, int length);

	// Vector elementwise multiplication
	public static native void Multiply_V8uV8u_V8u(byte[] xArray, byte[] yArray, byte[] productArray, int length);
	public static native void Multiply_V8uV8u_V16u(byte[] xArray, byte[] yArray, short[] productArray, int length);
	public static native void Multiply_V8sV8s_V16s(byte[] xArray, byte[] yArray, short[] productArray, int length);
	public static native void Multiply_V16uV16u_V16u(short[] xArray, short[] yArray, short[] productArray, int length);
	public static native void Multiply_V16uV16u_V32u(short[] xArray, short[] yArray, int[] productArray, int length);
	public static native void Multiply_V16sV16s_V32s(short[] xArray, short[] yArray, int[] productArray, int length);
	public static native void Multiply_V32uV32u_V32u(int[] xArray, int[] yArray, int[] productArray, int length);
	public static native void Multiply_V32uV32u_V64u(int[] xArray, int[] yArray, long[] productArray, int length);
	public static native void Multiply_V32sV32s_V64s(int[] xArray, int[] yArray, long[] productArray, int length);
	public static native void Multiply_V64uV64u_V64u(long[] xArray, long[] yArray, long[] productArray, int length);
	public static native void Multiply_V32fV32f_V32f(float[] xArray, float[] yArray, float[] productArray, int length);
	public static native void Multiply_V64fV64f_V64f(double[] xArray, double[] yArray, double[] productArray, int length);

	// Vector elementwise multiplication and addition
	public static native void MultiplyAdd_V32fV32fV32f_V32f(float[] xArray, float[] yArray, float[] zArray, float[] macArray, int length);
	public static native void MultiplyAdd_V64fV64fV64f_V64f(double[] xArray, double[] yArray, double[] zArray, double[] macArray, int length);
	public static native void MultiplyAdd_V32fS32fIV32f_IV32f(float[] xArray, float y, float[] zArray, int length);
	public static native void MultiplyAdd_V64fS64fIV64f_IV64f(double[] xArray, double y, double[] zArray, int length);

	// Dot product
	public static native void DotProduct_V32fV32f_S32f(float[] xArray, float[] yArray, float dotProduct, int length);
	public static native void DotProduct_V64fV64f_S64f(double[] xArray, double[] yArray, double dotProduct, int length);

	// Summation of squares (squared L2 norm)
	public static native void SumSquares_V32f_S32f(float[] numberArray, float sumSquares, int length);
	public static native void SumSquares_V64f_S64f(double[] numberArray, double sumSquares, int length);

}
