/*
 *                      Yeppp! library build framework
 *
 * This file is part of Yeppp! library infrastructure and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

package info.yeppp.Build;

import java.util.List;

public interface JavaCompiler {

	public BuildMessages compile(String sourcePath);

	public String getObjectPath(String sourcePath);

	public void setSourceDirectory(String sourceDirectory);

	public String getSourceDirectory();

	public void setClassDirectory(String classDirectory);

	public String getClassDirectory();

	public void setDebugEnabled(boolean debugEnabled);

	public boolean getDebugEnabled();

	public boolean addClassPathDirectory(String classPath);

	public boolean removeClassPathDirectory(String classPath);

	public void clearClassPathDirectories();

}
