#!/bin/bash
CXX=g++
CXXFLAGS="-m64 -nostdlib -fPIC -ffunction-sections -Wno-psabi -mtune=corei7 -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -Isources -Iheaders -Wa,--noexecstack -DYEP_BUILD_LIBRARY -c"
CC=gcc
AS=nasm
ASFLAGS="-f elf64"
RM=rm
RMFLAGS="-rf"

$RM $RMFLAGS "binaries/x64-linux-sysv-default" >NUL 2>NUL
mkdir "binaries/x64-linux-sysv-default/" >NUL 2>NUL
mkdir "binaries/x64-linux-sysv-default/library/" >NUL 2>NUL
mkdir "binaries/x64-linux-sysv-default/core/" >NUL 2>NUL
mkdir "binaries/x64-linux-sysv-default/math/" >NUL 2>NUL

$CXX -Os $CXXFLAGS sources/core/Add.disp.cpp -o binaries/x64-linux-sysv-default/core/Add.disp.o

$CXX -O3 $CXXFLAGS sources/core/Add.impl.cpp -o binaries/x64-linux-sysv-default/core/Add.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/Add.x64-sysv.o sources/core/Add.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/Subtract.disp.cpp -o binaries/x64-linux-sysv-default/core/Subtract.disp.o

$CXX -O3 $CXXFLAGS sources/core/Subtract.impl.cpp -o binaries/x64-linux-sysv-default/core/Subtract.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/Subtract.x64-sysv.o sources/core/Subtract.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/Multiply.disp.cpp -o binaries/x64-linux-sysv-default/core/Multiply.disp.o

$CXX -O3 $CXXFLAGS sources/core/Multiply.impl.cpp -o binaries/x64-linux-sysv-default/core/Multiply.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/Multiply.x64-sysv.o sources/core/Multiply.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/MultiplyAdd.disp.cpp -o binaries/x64-linux-sysv-default/core/MultiplyAdd.disp.o

$CXX -O3 $CXXFLAGS sources/core/MultiplyAdd.impl.cpp -o binaries/x64-linux-sysv-default/core/MultiplyAdd.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/MultiplyAdd.x64-sysv.o sources/core/MultiplyAdd.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/Negate.disp.cpp -o binaries/x64-linux-sysv-default/core/Negate.disp.o

$CXX -O3 $CXXFLAGS sources/core/Negate.impl.cpp -o binaries/x64-linux-sysv-default/core/Negate.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/Negate.x64-sysv.o sources/core/Negate.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/DotProduct.disp.cpp -o binaries/x64-linux-sysv-default/core/DotProduct.disp.o

$CXX -O3 $CXXFLAGS sources/core/DotProduct.impl.cpp -o binaries/x64-linux-sysv-default/core/DotProduct.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/DotProduct.x64-sysv.o sources/core/DotProduct.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/core/SumSquares.disp.cpp -o binaries/x64-linux-sysv-default/core/SumSquares.disp.o

$CXX -O3 $CXXFLAGS sources/core/SumSquares.impl.cpp -o binaries/x64-linux-sysv-default/core/SumSquares.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/core/SumSquares.x64-sysv.o sources/core/SumSquares.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/math/Log.disp.cpp -o binaries/x64-linux-sysv-default/math/Log.disp.o

$CXX -O3 $CXXFLAGS sources/math/Log.impl.cpp -o binaries/x64-linux-sysv-default/math/Log.impl.o

$AS $ASFLAGS -o binaries/x64-linux-sysv-default/math/Log.x64-sysv.o sources/math/Log.x64-sysv.asm

$CXX -Os $CXXFLAGS sources/library/Init.cpp -o binaries/x64-linux-sysv-default/library/Init.o

$CXX -Os $CXXFLAGS sources/library/Cpu.cpp -o binaries/x64-linux-sysv-default/library/Cpu.o

$CXX -Os $CXXFLAGS sources/library/Timer.cpp -o binaries/x64-linux-sysv-default/library/Timer.o

$CXX -Os $CXXFLAGS sources/library/Strings.cpp -o binaries/x64-linux-sysv-default/library/Strings.o

$CXX -nostdlib -Wl,-soname,libyeppp.so -shared -Wl,--version-script=sources/libyeppp.so.map binaries/x64-linux-sysv-default/core/Add.disp.o binaries/x64-linux-sysv-default/core/Add.impl.o binaries/x64-linux-sysv-default/core/Add.x64-sysv.o binaries/x64-linux-sysv-default/core/Subtract.disp.o binaries/x64-linux-sysv-default/core/Subtract.impl.o binaries/x64-linux-sysv-default/core/Subtract.x64-sysv.o binaries/x64-linux-sysv-default/core/Multiply.disp.o binaries/x64-linux-sysv-default/core/Multiply.impl.o binaries/x64-linux-sysv-default/core/Multiply.x64-sysv.o binaries/x64-linux-sysv-default/core/MultiplyAdd.disp.o binaries/x64-linux-sysv-default/core/MultiplyAdd.impl.o binaries/x64-linux-sysv-default/core/MultiplyAdd.x64-sysv.o binaries/x64-linux-sysv-default/core/Negate.disp.o binaries/x64-linux-sysv-default/core/Negate.impl.o binaries/x64-linux-sysv-default/core/Negate.x64-sysv.o binaries/x64-linux-sysv-default/core/DotProduct.disp.o binaries/x64-linux-sysv-default/core/DotProduct.impl.o binaries/x64-linux-sysv-default/core/DotProduct.x64-sysv.o binaries/x64-linux-sysv-default/core/SumSquares.disp.o binaries/x64-linux-sysv-default/core/SumSquares.impl.o binaries/x64-linux-sysv-default/core/SumSquares.x64-sysv.o binaries/x64-linux-sysv-default/math/Log.disp.o binaries/x64-linux-sysv-default/math/Log.impl.o binaries/x64-linux-sysv-default/math/Log.x64-sysv.o binaries/x64-linux-sysv-default/library/Cpu.o binaries/x64-linux-sysv-default/library/Timer.o binaries/x64-linux-sysv-default/library/Init.o binaries/x64-linux-sysv-default/library/Strings.o -Wl,--no-undefined -Wl,-z,noexecstack -o binaries/x64-linux-sysv-default/libyeppp.so

strip binaries/x64-linux-sysv-default/libyeppp.so
strip -R .comment -R .note.gnu.build-id binaries/x64-linux-sysv-default/libyeppp.so
